Input = class('Input')

function Input:init()
    self.actions = {}
    self.state_pressed = {}
    self.state_released = {} 
end

function Input:update(dt)
    self.state_pressed = {}
    self.state_released = {} 
end

function Input:bind(action, keys)
    self.actions[action] = keys
end

function Input:pressed(action)
    for _, key in pairs(self.actions[action]) do
        if self.state_pressed[key] then return self.state_pressed[key] end
    end 
end

function Input:released(action)
    for _, key in pairs(self.actions[action]) do
        if self.state_released[key] then return self.state_released[key] end
    end
end

function Input:down(action)
    for _, key in pairs(self.actions[action]) do
        if love.keyboard.isDown(key) then return true end
        if key == 'lmb' then
            if love.mouse.isDown('l') then return true end
        end
        if key == 'rmb' then
            if love.mouse.isDown('r') then return true end
        end
    end
end

function Input:keypressed(key)
    self.state_pressed[key] = true
end

function Input:keyreleased(key)
    self.state_released[key] = true 
end

function Input:mousepressed(x, y, button)
    if button == 'l' then button = 'lmb' end
    if button == 'r' then button = 'rmb' end
    self.state_pressed[button] = {x = x, y = y}
end

function Input:mousereleased(x, y, button)
    if button == 'l' then button = 'lmb' end
    if button == 'r' then button = 'rmb' end
    self.state_released[button] = {x = x, y = y}
end
