UI = class('UI')

function UI:init()
    self.attack_1_alpha = 0
    self.attack_2_alpha = 0
    self.attack_3_alpha = 0
    self.attack_4_alpha = 0
end

function UI:update(dt)
    local attack_1_time_elapsed = love.timer.getTime() - game.current_world.player.attack_1_last_time
    local attack_1_time_left = game.current_world.player.attack_1_cooldown - attack_1_time_elapsed
    if attack_1_time_left <= 0 then self.attack_1_alpha = 0 else self.attack_1_alpha = 255 - 63.75*attack_1_time_elapsed end
    local attack_2_time_elapsed = love.timer.getTime() - game.current_world.player.attack_2_last_time
    local attack_2_time_left = game.current_world.player.attack_2_cooldown - attack_2_time_elapsed
    if attack_2_time_left <= 0 then self.attack_2_alpha = 0 else self.attack_2_alpha = 255 - 12.75*attack_2_time_elapsed end
    local attack_3_time_elapsed = love.timer.getTime() - game.current_world.player.attack_3_last_time
    local attack_3_time_left = game.current_world.player.attack_3_cooldown - attack_3_time_elapsed
    if attack_3_time_left <= 0 then self.attack_3_alpha = 0 else self.attack_3_alpha = 255 - 42.5*attack_3_time_elapsed end
    local attack_4_time_elapsed = love.timer.getTime() - game.current_world.player.attack_4_last_time
    local attack_4_time_left = game.current_world.player.attack_4_cooldown - attack_4_time_elapsed
    if attack_4_time_left <= 0 then self.attack_4_alpha = 0 else self.attack_4_alpha = 255 - 5.66667*attack_4_time_elapsed end
end

function UI:drawTutorial()
    love.graphics.setFont(tutorial_text)
    love.graphics.setColor(0, 0, 0, 192)
    love.graphics.rectangle('fill', 0, 0, game_width, game_height)
    love.graphics.setColor(255, 255, 255, 255)
    outlineText("Left = Health", 142, 580, {255, 255, 255}, 255) 
    outlineText("Right = Mana", 526, 580, {255, 255, 255}, 255) 
    outlineText("Middle = Spells\n Use with keys:", 322, 520, {255, 255, 255}, 255)
    outlineText("1", 328, 560, {255, 255, 255}, 255)
    outlineText("2", 372, 560, {255, 255, 255}, 255)
    outlineText("3", 420, 560, {255, 255, 255}, 255)
    outlineText("4", 467, 560, {255, 255, 255}, 255)
    
    love.graphics.setFont(font_damage_pop_big)
    local w = nil
    w = font_damage_pop_big:getWidth("Your goal is to kill all")
    outlineText("Your goal is to kill all", 400 - w/2, 40, {255, 255, 255}, 255)
    w = font_damage_pop_big:getWidth("qt cuddly bubbly wubbly children.")
    outlineText("qt cuddly bubbly wubbly children.", 400 - w/2, 80, {255, 255, 255}, 255)
    w = font_damage_pop_big:getWidth("Press space to start!")
    outlineText("Press space to start!", 400 - w/2, 400, {255, 255, 255}, 255)
    w = font_damage_pop_big:getWidth("ESC to pause")
    outlineText("ESC to pause", 400 - w/2, 440, {255, 255, 255}, 255)
end

function UI:drawPaused()
    love.graphics.setFont(font_damage_pop_big)
    love.graphics.setColor(0, 0, 0, 192)
    love.graphics.rectangle('fill', 0, 0, game_width, game_height)
    love.graphics.setColor(255, 255, 255, 255)
    local w = font_damage_pop_big:getWidth("ESC to unpause")
    outlineText("ESC to unpause", 400 - w/2, 300, {255, 255, 255}, 255) 
end

function UI:drawLost()
    love.graphics.setFont(font_damage_pop_big)
    love.graphics.setColor(0, 0, 0, 192)
    love.graphics.rectangle('fill', 0, 0, game_width, game_height)
    love.graphics.setColor(255, 255, 255, 255)
    local w = font_damage_pop_big:getWidth("You lost!")
    outlineText("You lost!", 400 - w/2, 240, {255, 255, 255}, 255) 
    w = font_damage_pop_big:getWidth("Press space to try again!")
    outlineText("Press space to try again!", 400 - w/2, 360, {255, 255, 255}, 255) 
end

function UI:drawWon()
    love.graphics.setFont(font_damage_pop_big)
    love.graphics.setColor(0, 0, 0, 192)
    love.graphics.rectangle('fill', 0, 0, game_width, game_height)
    love.graphics.setColor(255, 255, 255, 255)
    local w = font_damage_pop_big:getWidth("You won!")
    outlineText("You won!", 400 - w/2, 200, {255, 255, 255}, 255) 
    w = font_damage_pop_big:getWidth("You are the hero the world deserves,")
    outlineText("You are the hero the world deserves,", 400 - w/2, 300, {255, 255, 255}, 255)
    w = font_damage_pop_big:getWidth("but not the one it needs right now.")
    outlineText("but not the one it needs right now.", 400 - w/2, 360, {255, 255, 255}, 255)
    w = font_damage_pop_big:getWidth("Press space to play again!")
    outlineText("Press space to play again!", 400 - w/2, 480, {255, 255, 255}, 255) 
end

function UI:draw()
    local x, y = game_width/2 - skill_ui:getWidth()/2, 620 - skill_ui:getHeight()
    love.graphics.draw(skill_ui, x, y)
    love.graphics.draw(bar, x - 160, 600)
    love.graphics.draw(bar, x + skill_ui:getWidth() + 10, 600)
    love.graphics.setColor(200, 96, 96, 192)
    love.graphics.rectangle('fill', x - 160 + 5, 600 + 5, 0.47*game.current_world.player.hp, 10)
    love.graphics.setColor(96, 96, 200, 192)
    love.graphics.rectangle('fill', x + skill_ui:getWidth() + 10 + 5, 600 + 5, 1.4*game.current_world.player.mana, 10)
    love.graphics.setColor(255, 255, 255, self.attack_1_alpha)
    love.graphics.draw(skill_overlay, x + 14, y + skill_ui:getHeight()/4 - 1) 
    love.graphics.setColor(255, 255, 255, 192)
    if self.attack_1_alpha == 0 then 
        if game.current_world.player.mana < game.current_world.player.attack_1_mana_cost then
            love.graphics.draw(skill_overlay_mana, x + 14 - 5, y + skill_ui:getHeight()/4 - 1 - 5)
        else love.graphics.draw(skill_overlay_yes, x + 14 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    else love.graphics.draw(skill_overlay_no, x + 14 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    love.graphics.setColor(255, 255, 255, self.attack_2_alpha)
    love.graphics.draw(skill_overlay, x + 62, y + skill_ui:getHeight()/4 - 1) 
    love.graphics.setColor(255, 255, 255, 192)
    if self.attack_2_alpha == 0 then 
        if game.current_world.player.mana < game.current_world.player.attack_2_mana_cost then
            love.graphics.draw(skill_overlay_mana, x + 62 - 5, y + skill_ui:getHeight()/4 - 1 - 5)
        else love.graphics.draw(skill_overlay_yes, x + 62 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    else love.graphics.draw(skill_overlay_no, x + 62 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    love.graphics.setColor(255, 255, 255, self.attack_3_alpha)
    love.graphics.draw(skill_overlay, x + 109, y + skill_ui:getHeight()/4 - 1) 
    love.graphics.setColor(255, 255, 255, 192)
    if self.attack_3_alpha == 0 then 
        if game.current_world.player.mana < game.current_world.player.attack_3_mana_cost then
            love.graphics.draw(skill_overlay_mana, x + 109 - 5, y + skill_ui:getHeight()/4 - 1 - 5)
        else love.graphics.draw(skill_overlay_yes, x + 109 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    else love.graphics.draw(skill_overlay_no, x + 109 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    love.graphics.setColor(255, 255, 255, self.attack_4_alpha)
    love.graphics.draw(skill_overlay, x + 157, y + skill_ui:getHeight()/4 - 1) 
    love.graphics.setColor(255, 255, 255, 192)
    if self.attack_4_alpha == 0 then 
        if game.current_world.player.mana < game.current_world.player.attack_4_mana_cost then
            love.graphics.draw(skill_overlay_mana, x + 157 - 5, y + skill_ui:getHeight()/4 - 1 - 5)
        else love.graphics.draw(skill_overlay_yes, x + 157 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    else love.graphics.draw(skill_overlay_no, x + 157 - 5, y + skill_ui:getHeight()/4 - 1 - 5) end
    love.graphics.setColor(255, 255, 255, 255)
end
