BSolid = class('BSolid', Entity)
BSolid:include(PhysicsRectangle)
BSolid:include(Timer)
BSolid:include(HittableRed)

function BSolid:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:physicsRectangleInit(self.world.world, x, y, 'static', settings.w or 32, settings.h or 32)
    self:timerInit()
    self:hittableInit(0.1)
    self.hp = 3
    self.particle_colors = {{172, 106, 52}, {142, 88, 43}, {102, 63, 31}}
end

function BSolid:update(dt)
    self.x, self.y = self.body:getPosition()
    self:timerUpdate(dt)
end

function BSolid:draw()
    if debug_draw then self:physicsRectangleDraw() end
    self:hittableDraw()
    love.graphics.draw(self.settings.visual, self.x-self.w/2, self.y-self.h/2)
    love.graphics.setColorMode('modulate')
    love.graphics.setColor(255, 255, 255, 255)
end

function BSolid:projectileHit()
    self:hittableHit()
    local color = table.random(self.particle_colors)
    local c1, c2 = {color[1], color[2], color[3], 255}, {color[1], color[2], color[3], 0}
    self.world:particleCreate('ProjHit', {position = {x = self.x - 4, y = self.y - 4},
                              colors = {c1[1], c1[2], c1[3], c1[4], c2[1], c2[2], c2[3], c2[4]}})
    self.hp = self.hp - 1
    self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y,
                            {size = 'small', text = "1", color = {240, 160, 160}})
    if self.hp <= 0 then
        self.dead = true
    end
end
