InfoUpText = class('InfoUpText', Entity)
InfoUpText:include(PhysicsRectangle)
InfoUpText:include(Timer)

function InfoUpText:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:timerInit()
    self:physicsRectangleInit(self.world.world, self.x, self.y, 'dynamic', 16, 16)
    self.text = settings.text or ""
    self.color = {255, 255, 255}
    self.alpha = 255
    self.size = 'small'

    self.timer:after(2, function() self.dead = true end)
    self.timer:tween(2, self, {alpha = 0}, 'in-out-cubic')
end

function InfoUpText:update(dt)
    self.x, self.y = self.body:getPosition()
    local vx, vy = self.body:getLinearVelocity()
    vy = vy - 100*dt
    self.body:setLinearVelocity(vx, vy)
    self:timerUpdate(dt)
end

function InfoUpText:draw()
    if debug_draw then self:physicsRectangleDraw() end
    if self.size == 'small' then love.graphics.setFont(font_damage_pop_small) end
    local w = font_damage_pop_small:getWidth(self.text)
    outlineText(self.text, self.x - w/2, self.y - self.h, self.color, self.alpha)
end
