Item = class('Item', Entity)
Item:include(PhysicsRectangle)
Item:include(Timer)

function Item:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:physicsRectangleInit(self.world.world, x, y, 'dynamic', 32, 32)
    self:timerInit()
    self.visual = settings.visual
    self.item_type = settings.item_type
    self.body:setFixedRotation(false)
    self.body:setAngularVelocity(math.prandom(-math.pi, math.pi))
    self.fixture:setRestitution(0.75)
    self.disable = true
    self.timer:after(2, function() self.disabled = false end)
end

function Item:update(dt)
    self.x, self.y = self.body:getPosition()
    self:timerUpdate(dt)
end

function Item:draw()
    if debug_draw then self:physicsRectangleDraw() end
    pushRotate(self.x, self.y, self.body:getAngle())
    local x, y = self.x - self.w/2, self.y - self.h/2
    love.graphics.draw(self.visual, x, y)
    love.graphics.pop()
    love.graphics.setColorMode('modulate')
    love.graphics.setColor(255, 255, 255, 255)
end

