NumberPopText = class('NumberPopText', Entity)
NumberPopText:include(PhysicsRectangle)
NumberPopText:include(Timer)

function NumberPopText:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:timerInit() 
    self:physicsRectangleInit(self.world.world, self.x, self.y, 'dynamic', 16, 16)
    local r = math.prandom(-3*math.pi/4, -math.pi/4)
    local v = math.prandom(200, 200)
    self.body:setLinearVelocity(v*math.cos(r), v*math.sin(r))
    self.text = settings.text or ""
    self.color = settings.color or {255, 255, 255}
    self.size = settings.size or 'small'
    self.alpha = 255
    self.scale = 1

    self.timer:after(1, function() self.dead = true end)
    self.timer:tween(2, self, {scale = 0.5}, 'in-out-cubic')
    self.timer:tween(1, self, {alpha = 0}, 'in-out-cubic')
end

function NumberPopText:update(dt)
    self.x, self.y = self.body:getPosition()
    local vx, vy = self.body:getLinearVelocity()
    vy = vy + 500*dt
    self.body:setLinearVelocity(vx, vy)
    self:timerUpdate(dt)
end

function NumberPopText:draw()
    if debug_draw then self:physicsRectangleDraw() end
    if self.size == 'small' then love.graphics.setFont(font_damage_pop_small)
    elseif self.size == 'medium' then love.graphics.setFont(font_damage_pop_medium)
    elseif self.size == 'big' then love.graphics.setFont(font_damage_pop_big) end
    outlineText(self.text, self.x - self.scale*self.w, self.y - self.scale*self.h, self.color, self.alpha, self.scale)
end
