Prop = class('Prop', Entity)
Prop:include(PhysicsRectangle)

function Prop:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:physicsRectangleInit(self.world.world, x, y, 'dynamic', 32, 32)
    self.n = settings.n or 0
    self.visual = tiles_data[settings.tile_data or 'props_trees'][self.n or 1]
    self.offset = Vector(-16, -32)
    self.particle_colors = {{149, 166, 50}, {118, 131, 43}, {92, 101, 37}}
end

function Prop:update(dt)
    self.x, self.y = self.body:getPosition()
end

function Prop:draw()
    if debug_draw then self:physicsRectangleDraw() end
    local x, y = self.x - self.w/2 + self.offset.x, self.y - self.h/2 + self.offset.y
    love.graphics.draw(self.visual, x, y)
end
