Solid = class('Solid', Entity)
Solid:include(PhysicsRectangle)

function Solid:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:physicsRectangleInit(self.world.world, x, y, 'static', settings.w or 32, settings.h or 32)
end

function Solid:update(dt)
    self.x, self.y = self.body:getPosition()
end

function Solid:draw()
    if debug_draw then self:physicsRectangleDraw() end
    local n_w, n_h = self.w/32, self.h/32
    for i = 1, n_w do
        for j = 1, n_h do
            love.graphics.draw(self.settings.visual, self.x-self.w/2+(i-1)*32, self.y-self.h/2+(j-1)*32)
        end
    end
end
