Trail = class('Trail', Entity)
Trail:include(Timer)

function Trail:init(world, x, y, settings)
    Entity.init(self, world, x, y, settings)
    self:timerInit() 
    self.color = settings.color or {255, 255, 255}
    self.alpha = settings.alpha or 255
    self.angle = settings.r or 0
    self.scale = settings.size or 1
    self.visual = settings.visual 
    self.timer:tween(0.4, self, {alpha = 0}, 'in-out-cubic')
    self.timer:after(0.4, function() self.dead = true end)
    self.shake_offset = Vector(0, 0)
end

function Trail:update(dt)
    self:timerUpdate(dt)
    self.shake_offset = Vector(math.prandom(-2, 2), math.prandom(-2, 2))
end

function Trail:draw()
    if self.color then 
        love.graphics.setColor(self.color[1], self.color[2], self.color[3], self.alpha) 
    end
    pushRotateScale(self.x, self.y, self.angle, self.scale)
    local x, y = self.x - self.visual:getWidth()/2, self.y - self.visual:getHeight()/2
    love.graphics.draw(self.visual, x + self.shake_offset.x, y + self.shake_offset.y)
    love.graphics.pop()
    love.graphics.setColor(255, 255, 255, 255)
end
