Attacker = {
    attackerInit = function(self)
        self.can_attack = true 
        self.main_attack_cooldown = 0.4
        self.attack_range = 0.5
        self.attack_speed = 600
        self.attack_size = 1
        self.attacking = false
        self.attacking_2 = false
        self.attacking_4 = false
        self.attack_1_cooldown = 4
        self.attack_2_cooldown = 20
        self.attack_2_duration = 4
        self.attack_3_cooldown = 6
        self.attack_4_cooldown = 45
        self.attack_4_duration = 4
        self.can_attack_1 = true
        self.can_attack_2 = true
        self.can_attack_3 = true
        self.can_attack_4 = true
        self.attack_1_last_time = -4
        self.attack_2_last_time = -20
        self.attack_3_last_time = -6
        self.attack_4_last_time = -45
        self.attack_1_mana_cost = 6
        self.attack_2_mana_cost = 10
        self.attack_3_mana_cost = 10
        self.attack_4_mana_cost = 50
        self.dmg_m = 1
        self.aspd_m = 1
        self.mov_m = 1
        self.range_m = 1
        self.mana_m = 1

        self.skill_1_colors = {{100, 160, 220}, {120, 160, 220}, {140, 180, 220}, {160, 180, 220}}
        self.skill_2_colors = {{200, 200, 100}, {200, 200, 120}, {220, 220, 140}, {220, 220, 160}}
        self.skill_2_player_color = {128, 128, 128}
        self.skill_4_colors = {{220, 160, 100}, {220, 160, 120}, {220, 180, 140}, {220, 180, 160}}
        self.skill_4_player_color = {128, 128, 128}
    end,

    normalAttack = function(self, r)
        if self.can_attack then
            self.attacking = true
            self.direction = angleToDirection(r)
            if not self.attacking_2 then
                self.world:cameraShakeAdd(3, 0.2)
                self.world:createToGroup('Projectile', 'Projectile', 
                self.x + math.cos(r)*15, self.y + math.sin(r)*15, 
                {ang_v = {math.pi/2, 2*math.pi}, r = r, v = self.attack_speed, 
                dmg = math.random(math.floor(5*self.dmg_m), math.floor(25*self.dmg_m)), 
                range = self.range_m*self.attack_range, size = self.attack_size, color = {255, 255, 255}})
            else
                if self.mana >= 1 then
                    self.mana = self.mana - 1
                    self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y, 
                                            {size = 'small', text = "-1", color = {186, 186, 240}}) 
                else return end
                self.world:cameraShakeAdd(3, 0.2)
                self.world:createToGroup('Projectile', 'Projectile', 
                self.x + math.cos(r)*15, self.y + math.sin(r)*15, 
                {ang_v = {math.pi/2, 2*math.pi}, r = r + math.prandom(-math.pi/12, math.pi/12), v = self.attack_speed, 
                range = self.range_m*self.attack_range, size = self.attack_size, color = table.random(self.skill_2_colors), 
                dmg = math.random(math.floor(10*self.dmg_m), math.floor(15*self.dmg_m))})
            end
            self.can_attack = false
            self.timer:after(self.main_attack_cooldown*self.aspd_m, function() 
                self.can_attack = true 
                self.attacking = false
            end)
        end
    end,
    
    skill_1 = function(self)
        if self.attacking_2 then return end
        if self.attacking_4 then return end
        if self.can_attack_1 then
            local cost = math.floor(self.attack_1_mana_cost*self.mana_m)
            if self.mana >= cost then 
                self.mana = self.mana - cost
                self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y, 
                                        {size = 'medium', text = "-" .. tostring(cost), color = {186, 186, 220}}) 
            else return end
            self.attack_1_last_time = love.timer.getTime()
            self.attacking = true
            self.timer:every(0.02, function()
                local r = math.random(0, 16*math.pi)
                local speed = math.prandom(0.75, 1.25)
                local range = math.prandom(0.5, 0.75)
                
                self.world:cameraShakeAdd(1, 0.2)
                self.world:createToGroup('Projectile', 'Projectile',
                self.x + math.cos(r)*15, self.y + math.sin(r)*15,
                {ang_v = {2*math.pi, 4*math.pi}, r = r, v = speed*self.attack_speed, dmg = 10,
                range = self.range_m*range*self.attack_range, size = self.attack_size, color = table.random(self.skill_1_colors),
                dmg = math.random(math.floor(25*self.dmg_m), math.floor(75*self.dmg_m))})
            end, 15)
            self.timer:after(0.02*15, function() self.attacking = false end)
            self.can_attack_1 = false
            self.timer:after(self.attack_1_cooldown, function()
                self.can_attack_1 = true
            end)
        end
    end,

    skill_2 = function(self)
        if self.attacking_4 then return end
        if self.can_attack_2 then
            local cost = math.floor(self.attack_2_mana_cost*self.mana_m)
            if self.mana >= cost then 
                self.mana = self.mana - cost 
                self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y, 
                                        {size = 'medium', text = "-" .. tostring(cost), color = {186, 186, 220}}) 
            else return end
            self.attack_2_last_time = love.timer.getTime()
            self.attacking_2 = true
            self.timer:tween(1, self, {skill_2_player_color = {200, 200, 128}}, 'in-out-cubic')
            local orig_aspd = self.main_attack_cooldown
            local orig_spd = self.attack_speed
            local orig_movspd = self.max_v
            local orig_range = self.attack_range
            self.main_attack_cooldown = 0.15
            self.max_v = 2*self.max_v
            self.attack_range = 1.5*self.attack_range
            self.attack_speed = 1.25*self.attack_speed
            self.timer:after(self.attack_2_duration, function()
                self.attacking_2 = false
                self.skill_2_player_color = {128, 128, 128}
                self.main_attack_cooldown = orig_aspd
                self.max_v = orig_movspd
                self.attack_range = orig_range
                self.attack_speed = orig_spd
            end)
            self.can_attack_2 = false
            self.timer:after(self.attack_2_cooldown, function()
                self.can_attack_2 = true
            end)
        end
    end,

    skill_3 = function(self, r)
        if self.attacking_4 then return end
        if self.can_attack_3 then
            local cost = math.floor(self.attack_3_mana_cost*self.mana_m)
            if self.mana >= cost then 
                self.mana = self.mana - cost 
                self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y, 
                                        {size = 'medium', text = "-" .. tostring(cost), color = {186, 186, 220}}) 
            else return end
            self.attack_3_last_time = love.timer.getTime()
            self.direction = angleToDirection(r)
            self:push(750, r, true)
            self.can_attack_3 = false
            self.timer:after(self.attack_3_cooldown, function()
                self.can_attack_3 = true
            end)
        end
    end,

    skill_4 = function(self, r)
        if self.attacking_2 then return end
        if self.can_attack_4 then
            local cost = math.floor(self.attack_4_mana_cost*self.mana_m)
            if self.mana >= cost then 
                self.mana = self.mana - cost 
                self.world:createToGroup('NumberPopText', 'NumberPopText', self.x, self.y, 
                                        {size = 'medium', text = "-" .. tostring(cost), color = {186, 186, 220}}) 
            else return end
            self.attack_4_last_time = love.timer.getTime()
            self.direction = angleToDirection(r)
            self.attacking_4 = true
            self.cant_move = true
            local orig_movspd = self.max_v
            self.timer:tween(1, self, {skill_4_player_color = {200, 160, 128}}, 'in-out-cubic')
            self.timer:after(self.attack_4_duration, function()
                self.cant_move = false
                self.attacking_4 = false
                self.max_v = orig_movspd
                self.skill_4_player_color = {128, 128, 128}
            end)
            self.timer:every(0.05, function()
                self:push(200, r-math.pi)
                self.world:cameraShakeAdd(5, 0.2)
                self.world:createToGroup('Projectile', 'Projectile',
                self.x + math.cos(r)*30, self.y + math.sin(r)*30,
                {ang_v = {0, 2*math.pi}, r = r + math.prandom(-math.pi/12, math.pi/12) , v = 2*self.attack_speed, 
                dmg = math.random(math.floor(20*self.dmg_m), math.floor(40*self.dmg_m)),
                range = self.range_m*2*self.attack_range, size = self.attack_size, color = table.random(self.skill_4_colors)})
            end, self.attack_4_duration/0.07)
            self.can_attack_4 = false
            self.timer:after(self.attack_4_cooldown, function()
                self.can_attack_4 = true
            end)
        end
    end,

    attackerUpdate = function(self, dt)
        local mouse_x, mouse_y = love.mouse.getPosition()
        local player_camera_x, player_camera_y = self.world.camera:cameraCoords(self.x, self.y)
        local r = math.atan2(mouse_y - player_camera_y, mouse_x - player_camera_x)

        if input:down('shoot') then self:normalAttack(r) end 
        if input:pressed('skill_1') then self:skill_1() end 
        if input:pressed('skill_2') then self:skill_2() end 
        if input:pressed('skill_3') then self:skill_3(r) end
        if input:pressed('skill_4') then self:skill_4(r) end
    end,

    attackerDraw = function(self)
        if self.attacking_2 then
            love.graphics.setColorMode('combine')
            love.graphics.setColor(unpack(self.skill_2_player_color))
        elseif self.attacking_4 then
            love.graphics.setColorMode('combine')
            love.graphics.setColor(unpack(self.skill_4_player_color))
        end
    end
}
