PlayerVisual = {
    visualInit = function(self, offset)
        self.animations = {}
        self.animations['walk_left'] = newAnimation(visuals['aang_walk_left'], 36, 34, 0.2, 0)
        self.animations['walk_right'] = newAnimation(visuals['aang_walk_right'], 36, 34, 0.2, 0)
        self.animations['attack_left'] = newAnimation(visuals['aang_attack_left'], 64, 34, 0.2, 0)
        self.animations['attack_right'] = newAnimation(visuals['aang_attack_right'], 64, 34, 0.2, 0)
        self.offset = offset
    end,

    visualUpdate = function(self, dt)
        if self.moving then
            if self.direction == 'left' then
                self.animations['walk_left']:update(dt)
            else self.animations['walk_right']:update(dt) end
        else
            if self.direction == 'left' then
                self.animations['walk_left']:seek(1)
            else self.animations['walk_right']:seek(1) end
        end

        if self.attacking or self.attacking_2 or self.attacking_4 then
            if self.direction == 'left' then
                self.animations['attack_left']:update(dt)
            else self.animations['attack_right']:update(dt) end
        end
    end,

    visualDraw = function(self)
        local x, y = self.body:getPosition()
        x, y = x - self.w/2 + self.offset.x, y - self.h/2 + self.offset.y
        if not self.attacking and not self.attacking_2 and not self.attacking_4 then
            if self.direction == 'left' then
                self.animations['walk_left']:draw(x, y)
            else self.animations['walk_right']:draw(x, y) end
        elseif self.attacking or self.attacking_2 or self.attacking_4 then
            if self.direction == 'left' then
                self.animations['attack_left']:draw(x - 28, y)
            else self.animations['attack_right']:draw(x, y) end
        end
    end
}
