Factory = {
    factoryInit = function(self)
        self.to_be_created = {}
    end,

    create = function(self, type, x, y, settings)
        table.insert(self.to_be_created, {type = type, x = x, y = y, settings = settings})
    end,

    createToGroup = function(self, group_name, type, x, y, settings)
        table.insert(self.to_be_created, {group_name = group_name, type = type, x = x, y = y, settings = settings})
    end,

    createPostWorldStep = function(self)
        for _, o in ipairs(self.to_be_created) do
            if o.type == 'Player' then
                local player = Player(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, player)
                else self:add(player) end
                self.player = player

            elseif o.type == 'Solid' then
                local solid = Solid(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, solid)
                else self:add(solid) end

            elseif o.type == 'Projectile' then
                local projectile = Projectile(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, projectile)
                else self:add(projectile) end

            elseif o.type == 'Trail' then
                local trail = Trail(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, trail)
                else self:add(trail) end

            elseif o.type == 'Prop' then
                local prop = Prop(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, prop)
                else self:add(prop) end

            elseif o.type == 'BSolid' then
                local bsolid = BSolid(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, bsolid)
                else self:add(bsolid) end

            elseif o.type == 'NumberPopText' then
                local nptext = NumberPopText(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, nptext)
                else self:add(nptext) end

            elseif o.type == 'Baby' then
                local baby = Baby(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, baby)
                else self:add(baby) end

            elseif o.type == 'Rogue' then
                local rogue = Rogue(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, rogue)
                else self:add(rogue) end

            elseif o.type == 'Monk' then
                local monk = Monk(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, monk)
                else self:add(monk) end

            elseif o.type == 'Item' then
                local item = Item(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, item)
                else self:add(item) end

            elseif o.type == 'InfoUpText' then
                local iutext = InfoUpText(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, iutext)
                else self:add(iutext) end

            elseif o.type == 'Ent' then
                local ent = Ent(self, o.x, o.y, o.settings)
                self.ent_id = ent.id
                if o.group_name then self:addToGroup(o.group_name, ent)
                else self:add(ent) end

            elseif o.type == 'Entie' then
                local entie = Entie(self, o.x, o.y, o.settings)
                if o.group_name then self:addToGroup(o.group_name, entie)
                else self:add(entie) end
            end
        end
        self.to_be_created = {}
    end
}
