Render = {
    renderInit = function(self)
        self.camera = Camera()
        self.camera_v = Vector(0, 0)
        self.camera_shake_v = Vector(0, 0)
        self.camera_v_multiplier = 0.03
        self.bounds = {x1 = -64, y1 = -64, x2 = 80*32+64, y2 = 80*32+64}
        self.game_width = game_width
        self.game_height = game_height
    end,

    renderUpdate = function(self, dt)
        local player_pos = Vector(0, 0)
        local world_pos = Vector(0, 0)
        local follow = Vector(0, 0)
        if self.player then
            player_pos.x, player_pos.y = self.player.x, self.player.y
            world_pos.x, world_pos.y = self.camera:worldCoords(love.mouse.getPosition())
            follow.x, follow.y = (player_pos.x + world_pos.x)/2, (player_pos.y + world_pos.y)/2
        end
        local camera_pos = Vector(0, 0)
        camera_pos.x, camera_pos.y = self.camera:pos()
        self.camera_v = Vector(follow.x - camera_pos.x, follow.y - camera_pos.y)
        self.camera:move(self.camera_v.x*self.camera_v_multiplier, self.camera_v.y*self.camera_v_multiplier)
        camera_pos.x, camera_pos.y = self.camera:pos()
        self.camera:lookAt(math.min(math.max(self.bounds.x1 + game_width/2, camera_pos.x), self.bounds.x2 - game_width/2),
                           math.min(math.max(self.bounds.y1 + game_height/2, camera_pos.y), self.bounds.y2 - game_height/2))
    end,

    entityInCameraView = function(self, entity)
        local cx, cy = self.camera:pos()
        if not entity.w or not entity.h then return true end
        if entity.x + entity.w/2 + 40 < cx - self.game_width/2 - 40 or entity.x - entity.w/2 - 40 > cx + self.game_width/2 + 40 then return false end
        if entity.y + entity.h/2 + 40 < cy - self.game_height/2 - 40 or entity.y - entity.h/2 - 40 > cy + self.game_height/2 + 40 then return false end
        return true
    end,

    renderAttach = function(self)
        self.camera:attach()
    end,

    renderDetach = function(self)
        self.camera:detach()
    end
}
